/**
 * Copyright (c) 2004-2014 Gabor Bergmann and Daniel Varro
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-v20.html.
 * 
 * SPDX-License-Identifier: EPL-2.0
 */
package org.eclipse.viatra.query.runtime.rete.recipes;

import org.eclipse.viatra.query.runtime.matchers.psystem.aggregations.IMultisetAggregationOperator;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Single Column Aggregator Recipe</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.viatra.query.runtime.rete.recipes.SingleColumnAggregatorRecipe#getMultisetAggregationOperator <em>Multiset Aggregation Operator</em>}</li>
 *   <li>{@link org.eclipse.viatra.query.runtime.rete.recipes.SingleColumnAggregatorRecipe#getAggregableIndex <em>Aggregable Index</em>}</li>
 *   <li>{@link org.eclipse.viatra.query.runtime.rete.recipes.SingleColumnAggregatorRecipe#getGroupByMask <em>Group By Mask</em>}</li>
 * </ul>
 *
 * @see org.eclipse.viatra.query.runtime.rete.recipes.RecipesPackage#getSingleColumnAggregatorRecipe()
 * @model
 * @generated
 */
public interface SingleColumnAggregatorRecipe extends AlphaRecipe, RederivableNodeRecipe {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = "Copyright (c) 2004-2014 Gabor Bergmann and Daniel Varro\nThis program and the accompanying materials are made available under the\nterms of the Eclipse Public License v. 2.0 which is available at\nhttp://www.eclipse.org/legal/epl-v20.html.\n\nSPDX-License-Identifier: EPL-2.0"; //$NON-NLS-1$

	/**
	 * Returns the value of the '<em><b>Multiset Aggregation Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Multiset Aggregation Operator</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Multiset Aggregation Operator</em>' attribute.
	 * @see #setMultisetAggregationOperator(IMultisetAggregationOperator)
	 * @see org.eclipse.viatra.query.runtime.rete.recipes.RecipesPackage#getSingleColumnAggregatorRecipe_MultisetAggregationOperator()
	 * @model dataType="org.eclipse.viatra.query.runtime.rete.recipes.AggregationOperator"
	 * @generated
	 */
	IMultisetAggregationOperator<?, ?, ?> getMultisetAggregationOperator();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra.query.runtime.rete.recipes.SingleColumnAggregatorRecipe#getMultisetAggregationOperator <em>Multiset Aggregation Operator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Multiset Aggregation Operator</em>' attribute.
	 * @see #getMultisetAggregationOperator()
	 * @generated
	 */
	void setMultisetAggregationOperator(IMultisetAggregationOperator<?, ?, ?> value);

	/**
	 * Returns the value of the '<em><b>Aggregable Index</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Aggregable Index</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Aggregable Index</em>' attribute.
	 * @see #setAggregableIndex(int)
	 * @see org.eclipse.viatra.query.runtime.rete.recipes.RecipesPackage#getSingleColumnAggregatorRecipe_AggregableIndex()
	 * @model
	 * @generated
	 */
	int getAggregableIndex();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra.query.runtime.rete.recipes.SingleColumnAggregatorRecipe#getAggregableIndex <em>Aggregable Index</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Aggregable Index</em>' attribute.
	 * @see #getAggregableIndex()
	 * @generated
	 */
	void setAggregableIndex(int value);

	/**
	 * Returns the value of the '<em><b>Group By Mask</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Group By Mask</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Group By Mask</em>' containment reference.
	 * @see #setGroupByMask(Mask)
	 * @see org.eclipse.viatra.query.runtime.rete.recipes.RecipesPackage#getSingleColumnAggregatorRecipe_GroupByMask()
	 * @model containment="true" resolveProxies="true" required="true"
	 * @generated
	 */
	Mask getGroupByMask();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra.query.runtime.rete.recipes.SingleColumnAggregatorRecipe#getGroupByMask <em>Group By Mask</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Group By Mask</em>' containment reference.
	 * @see #getGroupByMask()
	 * @generated
	 */
	void setGroupByMask(Mask value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model kind="operation" unique="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='<%org.eclipse.viatra.query.runtime.rete.recipes.MonotonicityInfo%> info = getOptionalMonotonicityInfo();\nif (info == null) {\n\treturn 1 + getGroupByMask().getSourceIndices().size();\n} else {\t\n\treturn info.getCoreMask().getSourceIndices().size() + info.getPosetMask().getSourceIndices().size();\n}'"
	 * @generated
	 */
	int getArity();

} // SingleColumnAggregatorRecipe
